var fs = require('fs');
var path = require('path');
var inlineSource = require('inline-source');

function readdir ( directory, callback ) {
    var result = [];

    if (fs.existsSync(directory)) {
        var files = fs.readdirSync(directory);
        files.forEach(function ( file ) {
            var filepath = path.join(directory, file);
            var stats = fs.statSync(filepath);
            if (stats.isFile()) {
                result.push(file);
            }
            if (stats.isDirectory()) {
                readdir(filepath).forEach(function ( filename ) {
                    result.push(path.join(file, filename));
                });
            }
        });
    }

    return result;
}

function HtmlInlineSourceWebpackPlugin ( options ) {
    if (!(this instanceof HtmlInlineSourceWebpackPlugin)) {
        throw 'Cannot call HtmlInlineSourceWebpackPlugin as a function.';
    }
    if (typeof options !== 'object') {
        throw 'HtmlInlineSourceWebpackPlugin require an object arguments.';
    }
    if (options instanceof Array) {
        this.options = options;
    } else {
        this.options = [options];
    }
}

function inline ( file, option ) {

}

HtmlInlineSourceWebpackPlugin.prototype.apply = function ( compiler ) {
    var options = this.options;
    var length = options.length;
    var outputPath = path.join(compiler.context, compiler.outputPath);
    compiler.plugin('done', function () {
        readdir(outputPath).forEach(function ( filename ) {
            if (/\.html$/.test(filename)) {
                for (var i = 0; i < l; i++) {
                    var option = options[i];
                    if (option.test instanceof RegExp) {
                        if (option.test.test(filename)) {
                            return inline(path.join(outputPath, filename), option);

                        }
                    } else {
                        return inline(path.join(outputPath, filename), option);
                    }
                }
            }
        });
    });
};

module.exports = HtmlInlineSourceWebpackPlugin;

// inlineSource(html, {
//     rootpath : '/Users/lixinliang/Desktop/DiffBox/dist/',
// })
// let html = inline(file, {
//     compress : false,
//     rootpath : path.resolve('dist'),
//     handlers ( source, context ) {
//         if (source && source.fileContent && !source.content) {
//             if (source.extension == 'css') {
//                 source.tag = 'style';
//                 source.content = source.fileContent.replace(/url\(.*?\)/g, function ( match ) {
//                     let url = match.substring(0, match.length - 1).substring(4);
//                     if (/^http(s?):\/\/|^data:image/.test(url)) {
//                         return match;
//                     } else {
//                         if (url.indexOf('?')) {
//                             url = url.split('?')[0];
//                         }
//                         return `url(${ path.join('dist', url) })`;
//                     }
//                 });
//             }
//             if (source.extension == 'js') {
//                 source.content = source.fileContent.trim();
//             }
//         }
//     },
// });
